#!/bin/bash

data_dir=/usr/src/app/data

#/geodata/live/HSI_whiting/bathymetry/Black_Sea_EMODNET_cold.tif
#/geodata/live/HSI_whiting/bathymetry/Black_Sea_EMODNET_warm.tif

#April-September

#assign the bathymetry by bate
declare -i current_date=$(date +%m) #declare variable as int
#echo $current_date
if [ $current_date -ge 4 ] && [ $current_date -le 9 ]
then
	bathymetry=$data_dir/Black_Sea_EMODNET_warm.tif
else
	bathymetry=$data_dir/Black_Sea_EMODNET_cold.tif
fi
#echo $bathymetry


#cretare SI for SST and SSS
bash /usr/src/app/HSI_SSS_forecast.sh
bash /usr/src/app/HSI_SST_forecast.sh

#calculate HSI from SI
for file in `ls $data_dir/download/tem/SI/*.tif | xargs -n 1 basename` # xargs -n 1 basename takes only the basename, without entire path
do 
#echo $file
SI_SST=$data_dir/download/tem/SI/$file
#echo $SI_SST
SI_SSS=$data_dir/download/sal/SI/sv03_bs_cmcc_sal_an_fc_d_${file:26:8}_SI.tif
#echo $SI_SSS
output_HSI=$data_dir/HSI/HSI_whiting_${file:26:8}.tif
if [ $current_date -ge 4 ] && [ $current_date -le 9 ]
then
	#gdal_calc.py -A $bathymetry -B $SI_SSS -C $SI_SST --overwrite --type='Float32' --NoDataValue=0 --outfile=$output_HSI --calc="(A*0.33)+(B*0.55)+(C*0.12)"
	gdal_calc.py -A $bathymetry -B $SI_SSS -C $SI_SST --overwrite --type='Float32' --NoDataValue=0 --outfile=$output_HSI --calc="(A*$1)+(B*$2)+(C*$3)"
else
	#gdal_calc.py -A $bathymetry -B $SI_SSS -C $SI_SST --overwrite --type='Float32' --NoDataValue=0 --outfile=$output_HSI --calc="A*0.38+B*0.49+C*0.13"
	gdal_calc.py -A $bathymetry -B $SI_SSS -C $SI_SST --overwrite --type='Float32' --NoDataValue=0 --outfile=$output_HSI --calc="A*$1+B*$2+C*$3"
fi
done

#add overviews
for file in `ls $data_dir/HSI/*.tif`
do
gdaladdo -r gauss $file 2 4 8 16 32 64 128
done

rm -rf $data_dir/download/*.tif
rm -rf $data_dir/download/*.nc
rm -rf $data_dir/download/*.tif
rm -rf $data_dir/download/*.tif
rm -rf $data_dir/download/*.tif
rm -rf $data_dir/download/*.nc
rm -rf $data_dir/download/*.tif
rm -rf $data_dir/download/*.tif
rm -rf $data_dir/download/*.tif



#define name for each tif renaming
name_day_2=$(date -d "-2 days" +%Y%m%d)
name_day_1=$(date -d "-1 days" +%Y%m%d)
name_day0=$(date +%Y%m%d)
name_day1=$(date -d "+1 days" +%Y%m%d)
name_day2=$(date -d "+2 days" +%Y%m%d)
name_day3=$(date -d "+3 days" +%Y%m%d)
name_day4=$(date -d "+4 days" +%Y%m%d)
name_day5=$(date -d "+5 days" +%Y%m%d)
name_day6=$(date -d "+6 days" +%Y%m%d)
name_day7=$(date -d "+7 days" +%Y%m%d)
name_day8=$(date -d "+8 days" +%Y%m%d)
name_day9=$(date -d "+9 days" +%Y%m%d)

lista=("$name_day_2" "$name_day_1" "$name_day0" "$name_day1" "$name_day2" "$name_day3" "$name_day4" "$name_day5" "$name_day6" "$name_day7" "$name_day8" "$name_day9") # creates the list of names to be used for the tif files (indexed starting with 0, therefore $i-1 is required

#### upload the new files to geoserver
#for i in {0..11}
#do
#curl -v -u admin:#skyf1sh@1 -XPOST -H "Content-type: text/plain" -d "file:/geodata/live/HSI_whiting/HSI/HSI_whiting_${lista[$i]}.tif" "http://localhost:8080/geoserver/rest/workspaces/skyfish/coveragestores/HSI_whiting/external.imagemosaic"
#done
# $? - checks if a command succeded or not (must be put right after the comand"
#ls /geodata/live/HSI_whiting/HSI/HSI_whiting_$name_day9.tif
#err_check=$(echo $?)
#if [[ $err_check != 0 ]]; then
#   echo "Something went wrong. Check the fucking script for CMEMS salinity forecast product." > /geodata/scripts/ERRORS/err_HSI_whiting_$name_day0.txt
#fi





